function Create(self)
	self.chargetimer = Timer()
	self.lagprooftimer = Timer()
	self.charge = 5000 --5 sec recharge per respawn
	self.maplimit = 8
	self.count = 0
	self.Team = 0
	--slightly modified weapon list
	_WepList = { "ViPeR", "SAR-12", "M75", "R78", "SRS900", "M50", "M925", "M353", "XMV-850", "XK2", "XRS10", "Fifty9", "R9", "Deermaster 6k", "Wilson", "AM76", "D49", "GRS9", "M802", "Knife", "Chainsaw", "HF Katana", "M763", "MRT6", "MRS38", "M280", "Lightning Gun", "HAMR", "G5", "JL21", "RX22A", };
end

function Destroy(self)

end

function MakeMerc(whichMode,whichTeam)
	--make a mercenery with a random gun.
    local merc;
	merc = CreateAHuman("Mercenary", "BW.rte")
    local gun;
	local which;
    which = math.floor(math.random(1,#(_WepList)))
	gun = CreateHDFirearm(_WepList[which], "BW.rte");

    merc:AddInventoryItem(gun);
--    merc:SetControllerMode(Controller.CIM_AI, -1);
    merc.AIMode = whichMode;
	merc.Team = whichTeam;
    return merc;
end

function Update(self)
	--Check if timer has passed and activates an effect to show the module is ready to use.
	if self.chargetimer:IsPastSimMS(self.charge) and not MovableMan:IsParticle(self.readyfx) then
		self.readyfx = CreateAEmitter("Module Ready Signal")
		self.readyfx.Pos = self.Pos - Vector(0,15)
		MovableMan:AddParticle(self.readyfx);
	end
	--each 300 sim MS, actually check the respawn stuff.
	if self.lagprooftimer:IsPastSimMS(300) then
		--if the charge-up time has passed, and the respawn point hasnt hit its limit, spawn an actor.
		--small respawns are limited to a quarter of the "maplimit" variable, to prevent one team from spamming actors.
		teamcount = 0
		for teamcountactor in MovableMan.Actors do
			if teamcountactor.Team == self.Team then
				teamcount = teamcount + 1
			end
		end
		if teamcount > (self.maplimit / 2) then
			self.chargetimer:Reset()
		end
		if (self.chargetimer:IsPastSimMS(self.charge)) then
			for countactor in MovableMan.Actors do
				self.count = self.count + 1
			end
			if self.count < self.maplimit then
				self.count = 0
				local spawnposX = self.Pos.X + math.random(-10,10)
				local spawnposY = self.Pos.Y + math.random(-10,10)
				local spawnpos = Vector(spawnposX,spawnposY)
				local spawnteam = self.Team
				actor = MakeMerc(Actor.AIMODE_GOTO, spawnteam)
				actor:FlashWhite(300);
				actor.Pos = spawnpos;
				MovableMan:AddActor(actor);
				local sound = CreateAEmitter("Teleport Sound Emitter");
				sound.Pos = spawnpos;
				MovableMan:AddParticle(sound);
				smokecount = 0
				while smokecount <= 8 do
					smoke = CreateMOSParticle("Tiny Smoke Ball 1", "Base.rte")
					smoke.Pos = Vector((spawnpos.X + math.random(-7,7)),(spawnpos.Y + math.random(-7,7)))
					smoke.Vel = Vector(math.random(1,5),math.random(1,5))
					MovableMan:AddParticle(smoke);
					smokecount = smokecount + 1
				end
				self.chargetimer:Reset()
				self.charge = 5000 + math.floor(math.random(-2500,5000))
				foundwaypoint = false
				while foundwaypoint ~= true do
					local whichbehaviour;
					whichbehaviour = math.random()
					if whichbehaviour > 0.85 then
						for stalkactor in MovableMan.Actors do
							actor:ClearAIWaypoints();
							actor:AddAISceneWaypoint(stalkactor.Pos);
							print("TEAM:"..spawnteam.."    STALKING: X-"..math.floor(stalkactor.Pos.X).." Y-"..math.floor(stalkactor.Pos.Y))
							foundwaypoint = true
						end
					elseif whichbehaviour > 0.3 then
						actor:ClearAIWaypoints();
						actor:AddAISceneWaypoint(Vector(SceneMan.Scene.Width * PosRand(),SceneMan.Scene.Height * PosRand()));
						foundwaypoint = true
					else
						actor.AIMode = Actor.AIMODE_PATROL
						foundwaypoint = true
					end
				end
				self.readyfx.Lifetime = 1
			end
		end
		self.lagprooftimer:Reset();
	end
	self.count = 0
end
